const BEGIN='2021-01-20';
const MAX_TAGS=20;

function show_global_stats() {
	clear(week_view.el);
	let back_div=document.createElement("div");
	back_div.appendChild(_button("Назад", ()=>{
		week_view.el.removeChild(back_div);
		week_view.week_header.style.display="block";
		week_view._reset();
	}));
	back_div.appendChild(_t(" Графики"));
	week_view.el.appendChild(back_div);

	week_view.el.appendChild(_br());

	let img=document.createElement("img");
	img.setAttribute("src", "data/cloud.png");
	img.style.width="100%"
	week_view.el.appendChild(img);
	week_view.el.appendChild(_br());


	img=document.createElement("img");
	img.setAttribute("src", "data/dpd.png");
	img.style.width="100%"
	week_view.el.appendChild(img);
	week_view.el.appendChild(_br());
	week_view.el.appendChild(_br());

	img=document.createElement("img");
	img.setAttribute("src", "data/ttpd.png");
	img.style.width="100%"
	week_view.el.appendChild(img);
	week_view.el.appendChild(_br());
	week_view.el.appendChild(_br());



	// dreams per day
	// total tags [begin; date]
}

function show_all_dreams() {
	// Show all dreams
	clear(week_view.el);

	let back_div=document.createElement("div");
	back_div.appendChild(_button("Назад", ()=>{
		week_view.el.removeChild(back_div);
		week_view.week_header.style.display="block";
		week_view._reset();
	}));
	back_div.appendChild(_t(" Просмотр ВСЕХ снов"));
	week_view.el.appendChild(back_div);

	week_view._tape=new DreamsTape(() => true);

	week_view.el.appendChild(week_view._tape.el);
	scrollTo(0, 0);
}

function show_all_authors() {
	clear(week_view.el);

	let back_div=document.createElement("div");
	back_div.appendChild(_button("Назад", ()=>{
		week_view.el.removeChild(back_div);
		week_view.week_header.style.display="block";
		week_view._reset();
	}));
	back_div.appendChild(_t(" Просмотр авторов за всё время"));
	week_view.el.appendChild(back_div);

	let sorted_authors=Object.keys(_authors).sort((a, b) => {
		return _authors[b] - _authors[a];
	});

	for (let i=0; i<sorted_authors.length; i++) {
		let author=sorted_authors[i];
		week_view.el.appendChild(author_banner(author));
		week_view.el.appendChild(_t(` (${_authors[author]})`));
		week_view.el.appendChild(_br());
	}
	scrollTo(0, 0);
	scrollTo(0, 0);
}

function show_all_tags() {
	clear(week_view.el);

	let back_div=document.createElement("div");
	back_div.appendChild(_button("Назад", ()=>{
		week_view.el.removeChild(back_div);
		week_view.week_header.style.display="block";
		week_view._reset();
	}));
	back_div.appendChild(_t(" Просмотр тегов за всё время"));
	week_view.el.appendChild(back_div);

	let sorted_tags=Object.keys(_tags).sort((a, b) => {
		return _tags[b] - _tags[a];
	});

	for (let i=0; i<sorted_tags.length; i++) {
		let tag=sorted_tags[i];
		week_view.el.appendChild(tag_banner(tag));
		week_view.el.appendChild(_t(` (${_tags[tag]})`));
		week_view.el.appendChild(_br());
	}
	scrollTo(0, 0);
	scrollTo(0, 0);
}

function clear(el) {
	while (el.children.length>0)
		el.removeChild(el.children[0]);
	el.innerHTML='';
}

var _tags, _authors;
function get_tags_count() {
	if (_tags===undefined)
		_compute_global();

	return Object.keys(_tags).length;
}

function get_authors_count() {
	if (_authors===undefined)
		_compute_global();

	return Object.keys(_authors).length;
}

function _compute_global() {
	_tags={};
	_authors={};

	db.forEach(dream => {
		if (dream.tags) dream.tags.forEach(tag => {
			_tags[tag]=1+(_tags[tag] || 0);
		});
		_authors[dream.author] = 1 + (_authors[dream.author] || 0);
	});
}


function get_last_dream_date() {
	let date;
	db.forEach(dream => {
		if (date===undefined || (dream.date && date<dream.date))
			date=dream.date;
	});

	if (date===undefined)
		return;

	return new Date(date);
}

var week_view;
class WeekView {
	// if date is unset then the date of the last dream is selected
	// date is either a string or a Date object
	constructor(date) {
		if (week_view!==undefined)
			throw Error('WeekView is a singletone');

		week_view=this;
		this.last_dream_date=get_last_dream_date();

		if (date===undefined)
			date=this.last_dream_date;

		if (typeof date==="string")
			date=new Date(date);

		this.el=document.createElement("div");
		this.el.className="week_view";

		this._date=date;
		this._reset();
	}

	_compute() {
		let shift=(this._date.getDay()+4)%7;

		this.wed=new Date(this._date.valueOf()-shift*24*60*60*1000);
		this.isowed=this.wed.toISOString().substr(0, 10);
		this.tue=new Date(this._date.valueOf()-(shift-6)*24*60*60*1000);
		this.isotue=this.tue.toISOString().substr(0, 10);
		this.week_no=Math.floor((this._date.valueOf()
			-new Date(BEGIN).valueOf()) /1000/60/60/24/7 + 1);

		this._dreams_this_week=0;
		this._authors_this_week={};
		this._tags_this_week={};
		db.forEach(dream => {
			if (dream.date && dream.date>=this.isowed
					&& dream.date<=this.isotue) {
				this._dreams_this_week++;
				this._authors_this_week[dream.author]=1+
					(this._authors_this_week[dream.author] || 0);
				if (dream.tags) dream.tags.forEach(tag => {
					this._tags_this_week[tag] = 1+
					(this._tags_this_week[tag] || 0);
				});
			}
		});
	}
	_create_prev_btn() {
		let btn=document.createElement("button");
		btn.innerText="<<";
		btn.onclick=()=>{
			this._date=new Date(this._date.valueOf()-7*24*60*60*1000);
			this._reset();
		};

		let week_no=Math.floor((this._date.valueOf()
			-new Date(BEGIN).valueOf()) /1000/60/60/24/7 + 1);

		if (week_no===1)
			btn.disabled=true;
		return btn;
	}

	_create_caption() {
		let el=document.createElement("span");
		el.className="week_caption";
		el.innerHTML=`
			Неделя № ${this.week_no}
			(${this.wed.toISOString().substr(0, 10)} &ndash;
			${this.tue.toISOString().substr(0, 10)})
		`;
		el.onclick=()=>{
			this._reset();
		};
		return el;
	}

	_create_next_btn() {
		let btn=document.createElement("button");
		btn.innerText=">>";
		btn.onclick=()=>{
			this._date=new Date(this._date.valueOf()+7*24*60*60*1000);
			this._reset();
		};

		if (this.last_dream_date<=this.tue)
			btn.disabled=true;

		return btn;
	}

	_create_stats() {
		let stats=document.createElement("div");

		// TODO authors list -> top
		// TODO authors -> link
		// TODO sort authors
		let sorted_authors=Object.keys(this._authors_this_week).sort(
			(a, b) => this._authors_this_week[b]
				- this._authors_this_week[a]);

		// TODO tags list -> top
		// TODO tag -> link

		let sorted_tags=Object.keys(this._tags_this_week).sort((a, b) => {
			return this._tags_this_week[b] - this._tags_this_week[a];
		});

		let tags=[];

		for (let i=0; i<MAX_TAGS && i<sorted_tags.length; i++) {
			let tag=sorted_tags[i];
			let tagc=this._tags_this_week[tag];
			tags.push(`<span class="tags_count">#${tag}</span> (${tagc})`);
		}

		let tags_suffix='';
		if (sorted_tags.length > MAX_TAGS)
			tags_suffix='...';

		let tags_count=Object.keys(this._tags_this_week).length;

		let authorc=get_authors_count();
		let tagc=get_tags_count();

		stats.appendChild(_bold("Общая статистика: "));
		stats.appendChild(_span("" + db.length, "link", show_all_dreams));
		stats.appendChild(_t(', '));
		stats.appendChild(_span('@'+authorc, "link author_banner", show_all_authors));
		stats.appendChild(_t(', '));
		stats.appendChild(_span('#'+tagc, "link tag_banner", show_all_tags));
		stats.appendChild(_t('. '));
		stats.appendChild(_span("Графики", "link", show_global_stats));
		stats.appendChild(_t('.'));

		stats.appendChild(_br());

		stats.appendChild(_bold(
			`Снов за неделю: ${this._dreams_this_week}`));
		stats.appendChild(_br());

		stats.appendChild(_bold(
			`Авторов за неделю (${sorted_authors.length}): `));

		for (let i=0; i<sorted_authors.length; i++) {
			let author=sorted_authors[i];
			if (i>0)
				stats.appendChild(_t(", "));
			stats.appendChild(author_banner(author));
			stats.appendChild(_t(' '));
			stats.appendChild(_span(`(${this._authors_this_week[author]})`,
					"link", ()=>{
				clear(week_view.el);

				let back_div=document.createElement("div");
				back_div.appendChild(_button("Назад", ()=>{
					week_view.el.removeChild(back_div);
					week_view.week_header.style.display="block";
					week_view._reset();
				}));
				back_div.appendChild(_t(` Все сны ${author} на ${this.week_no} `
					+ `неделе (${this.isowed} – ${this.isotue})`));
				week_view.el.appendChild(back_div);

				week_view._tape=new DreamsTape(dream => dream.author===author
					&& dream.date >= this.isowed
					&& dream.date <= this.isotue);

				week_view.el.appendChild(week_view._tape.el);
				scrollTo(0, 0);
			}));
		}

		stats.appendChild(_br());

		stats.appendChild(_bold(`Теги за неделю (`));
		stats.appendChild(_span(`${Object.keys(this._tags_this_week).length}`,
				"link", ()=>{
			clear(week_view.el);

			let back_div=document.createElement("div");
			back_div.appendChild(_button("Назад", ()=>{
				week_view.el.removeChild(back_div);
				week_view.week_header.style.display="block";
				week_view._reset();
			}));
			back_div.appendChild(_t(` Все теги на ${this.week_no} `
				+ `неделе (${this.isowed} – ${this.isotue})`));
			week_view.el.appendChild(back_div);

			week_view.el.appendChild(_span(`Теги за всё время: ${Object.keys(_tags).length}`,
					"link", ()=>{
				show_all_tags();
			}));
			week_view.el.appendChild(_br());
			for (let i=0; i<sorted_tags.length; i++) {
				let tag=sorted_tags[i];
				week_view.el.appendChild(tag_banner(tag));
				week_view.el.appendChild(_t(' ('));
				week_view.el.appendChild(_span(`${this._tags_this_week[tag]}`,
						"link", ()=>{
					clear(week_view.el);

					let back_div=document.createElement("div");
					back_div.appendChild(_button("Назад", ()=>{
						week_view.el.removeChild(back_div);
						week_view.week_header.style.display="block";
						week_view._reset();
					}));
					back_div.appendChild(_t(` Все сны с тегом ${tag} на ${this.week_no} `
						+ `неделе (${this.isowed} – ${this.isotue})`));
					week_view.el.appendChild(back_div);

					week_view._tape=new DreamsTape(dream => dream.tags 
						&& dream.tags.indexOf(tag)!==-1
						&& dream.date >= this.isowed
						&& dream.date <= this.isotue);

					week_view.el.appendChild(week_view._tape.el);
					scrollTo(0, 0);
				}));
				week_view.el.appendChild(_t(', за всё время: '));
				week_view.el.appendChild(_span(`${_tags[tag]}`,
						"link", ()=>{
					clear(week_view.el);

					let back_div=document.createElement("div");
					back_div.appendChild(_button("Назад", ()=>{
						week_view.el.removeChild(back_div);
						week_view.week_header.style.display="block";
						week_view._reset();
					}));
					back_div.appendChild(_t(` Все сны с тегом ${tag}`));
					week_view.el.appendChild(back_div);

					week_view._tape=new DreamsTape(dream => dream.tags 
						&& dream.tags.indexOf(tag)!==-1);

					week_view.el.appendChild(week_view._tape.el);
					scrollTo(0, 0);
				}));
				week_view.el.appendChild(_t(')'));
				week_view.el.appendChild(_br());
			}
			scrollTo(0, 0);
		}));
		stats.appendChild(_bold('): '));

		for (let i=0; i<sorted_tags.length && i<MAX_TAGS; i++) {
			let tag=sorted_tags[i];

			if (i>0)
				stats.appendChild(_t(", "));

			stats.appendChild(tag_banner(tag));
			stats.appendChild(_t(' '));
			stats.appendChild(_span(`(${this._tags_this_week[tag]})`,
					"link", ()=>{
				clear(week_view.el);

				let back_div=document.createElement("div");
				back_div.appendChild(_button("Назад", ()=>{
					week_view.el.removeChild(back_div);
					week_view.week_header.style.display="block";
					week_view._reset();
				}));
				back_div.appendChild(_t(` Все сны с тегом ${tag} на ${this.week_no} `
					+ `неделе (${this.isowed} – ${this.isotue})`));
				week_view.el.appendChild(back_div);

				week_view._tape=new DreamsTape(dream => dream.tags 
					&& dream.tags.indexOf(tag)!==-1
					&& dream.date >= this.isowed
					&& dream.date <= this.isotue);

				week_view.el.appendChild(week_view._tape.el);
				scrollTo(0, 0);
			}));
		}

		`
			<br/>
			<b>Тегов за неделю (${tags_count}):</b> ${tags.join(", ")}
			${tags_suffix}
			(тегов за всё время: ${get_tags_count()})
			<br/>
		`;

		return stats;
	}

	_create_day_banner(date, cb) {
		let el=document.createElement("div");
		let weekday=["вс", "пн", "вт", "ср", "чт", "пт", "сб"]
			[date.getDay()];
		let month=date.getMonth()+1;
		let short_date=date.getDate()+'.'
			+ (month<10? '0': '') + month;
		let authors={}, dreamsc=0, tags={};
		
		db.forEach(dream => {
			if (dream.date != date.toISOString().substr(0, 10))
				return;
			dreamsc++;
			authors[dream.author]=true;
			dream.tags.forEach(tag => {
				tags[tag]=true;
			});
		});
		let authorsc=Object.keys(authors).length;
		let tagsc=Object.keys(tags).length;
		el.innerHTML=`
			<span class="date_banner">${weekday} ${short_date}</span> <br/>
			${dreamsc} 
			<span class="author_count">@${authorsc}</span>
			<span class="tags_count">#${tagsc}</span>
		`;
		el.className="day_banner";

		el.onclick=()=>{
			this.el.removeChild(this._tape.el);

			this._tape=new DreamsTape(dream => {
				return dream.date == date.toISOString().substr(0, 10);
			});

			this.el.appendChild(this._tape.el);
			scrollTo(0, 0);

			if (cb) cb();
			el.className="day_banner_active";
		};

		return el;
	}

	_create_days() {
		let stripe=document.createElement("table");
		let tr=document.createElement("tr");
		stripe.appendChild(tr);
		for (let i=0; i<7; i++) {
			let date=new Date(this.wed.valueOf() + i*24*60*60*1000);
			let td=document.createElement("td");
			tr.appendChild(td);
			td.appendChild(this._create_day_banner(date, ()=>{
				console.log('here');
				tr.querySelectorAll('.day_banner_active').forEach(el => {
					el.className='day_banner';
					console.log('there');
				});
			}));
		}

		return stripe;
	}

	_reset() {
		this._compute();
		clear(this.el);
		this.week_header=document.createElement("div");
		this.week_header.appendChild(this._create_prev_btn());
		this.week_header.appendChild(this._create_caption());
		this.week_header.appendChild(this._create_next_btn());
		this.week_header.appendChild(document.createElement("br"));
		this.week_header.appendChild(this._create_stats());
		this.week_header.appendChild(this._create_days());
		this.el.appendChild(this.week_header);

		this._tape=new DreamsTape(dream => {
			return dream.date >= this.isowed
				&& dream.date <= this.isotue;
		});
		this.el.appendChild(this._tape.el);
		scrollTo(0, 0);
	}

}

function _button(caption, onclick) {
	let btn=document.createElement("button");
	btn.innerText=caption;
	if (onclick!==undefined)
		btn.onclick=onclick;
	return btn;
}

function _t(text) { return document.createTextNode(text); }

function _bold(text) {
	let b=document.createElement("b");
	b.innerText=text;
	return b;
}

function _span(text, cls, onclick) {
	let span=document.createElement("span");

	span.innerText=text;

	if (cls!==undefined)
		span.className=cls;

	if (onclick!==undefined)
		span.onclick=onclick;

	return span;
}

function _br() {
	return document.createElement("br");
}

class DreamsTape {
	constructor(filter) {
		if (filter===undefined)
			filter=()=>true;

		this.el=document.createElement("div");

		this._filter=filter;

		this._reset();
	}

	_reset() {
		clear(this.el);

		let dreams=[];

		db.forEach(dream => {
			if (this._filter(dream))
				dreams.push(dream);
		});

		dreams=dreams.sort((a, b)=> {
			if (a.date < b.date)
				return -1;
			else if (a.date > b.date)
				return 1;
			else
				return 0;
		});

		dreams.forEach(dream => {
			this.el.appendChild(new Dream(dream).el);
		});
	}
}

class Dream {
	constructor(dream) {
		this._dream=dream;

		this.el=document.createElement("div");
		this.el.className="dream";
		this._reset();
	}

	_reset() {
		clear(this.el);

		this.el.appendChild(author_banner(this._dream.author));
		this.el.appendChild(document.createTextNode(' '));
		this.el.appendChild(date_banner(this._dream.date));
		this.el.appendChild(document.createTextNode(' '));
		let a=document.createElement('a');
		let pid=this._dream.pid;
		a.setAttribute("target", "blank");
		a.setAttribute("href", `https://dreamhackers.eu/viewtopic.php?p=${pid}#p${pid}`);
		a.innerHTML=pid;
		a.className='graylink';
		this.el.appendChild(a);
		this.el.appendChild(document.createElement("br"));
		
		let dream_html=document.createElement("div");
		dream_html.className="dream_html";
		dream_html.innerHTML=this._dream.html;

		this.el.appendChild(dream_html);

		let tags=document.createElement("div");
		if (this._dream.tags) this._dream.tags.forEach(tag => {
			if (tags.children.length>0)
				tags.appendChild(document.createTextNode(' '));
			tags.appendChild(tag_banner(tag));
		});
		this.el.appendChild(tags);
	}
}

function author_banner(author) {
	let el=document.createElement("span");
	el.appendChild(_span("@", "author_banner_at"));
	el.appendChild(_span(author, "author_banner", ()=>{
		clear(week_view.el);

		let back_div=document.createElement("div");
		back_div.appendChild(_button("Назад", ()=>{
			week_view.week_header.style.display="block";
			week_view._reset();
		}));
		back_div.appendChild(_t(` Все сны ${author}`));
		week_view.el.appendChild(back_div);

		week_view._tape=new DreamsTape(dream => dream.author===author);

		week_view.el.appendChild(week_view._tape.el);
		scrollTo(0, 0);
	}));
	return el;
}

function date_banner(date) {
	let el=document.createElement("span");
	el.className="date_banner";
	el.innerHTML=date;
	el.onclick=()=>{
		clear(week_view.el);

		let back_div=document.createElement("div");
		back_div.appendChild(_button("Назад", ()=>{
			week_view._reset();
		}));
		back_div.appendChild(_t(` Все сны ${date}`));
		week_view.el.appendChild(back_div);

		week_view._tape=new DreamsTape(dream => dream.date===date);

		week_view.el.appendChild(week_view._tape.el);
		scrollTo(0, 0);
	}
	return el;
}

function tag_banner(tag) {
	let el=document.createElement("span");
	el.className="tag_banner";
	el.innerHTML='#'+tag;
	el.onclick=()=>{
		clear(week_view.el);

		let back_div=document.createElement("div");
		back_div.appendChild(_button("Назад", ()=>{
			week_view.el.removeChild(back_div);
			week_view.week_header.style.display="block";
			week_view._reset();
		}));
		back_div.appendChild(_t(` Все сны с тегом ${tag}`));
		week_view.el.appendChild(back_div);

		week_view._tape=new DreamsTape(dream => dream.tags 
			&& dream.tags.indexOf(tag)!==-1);

		week_view.el.appendChild(week_view._tape.el);
		scrollTo(0, 0);
	}
	return el;
}

function main() {
	document.body.appendChild(new WeekView().el);
}

function show_week(n) {
	// Week 1 is Jan 20 .. Jan 26

}
